<div id="otherApp" v-cloak>
    <div class="d-flex align-items-center pb-2">
        <h4 class="font-weight-bold m-0 font-size-14"><i class="fa fa-file-alt mr-2"></i>Other</h4>
        <span class="mx-2 text-secondary">|</span>
        <a class="py-0 font-weight-normal c-pointer" v-on:click.prevent="showPopup('other-popup')">Add</a>
    </div>
    <table class="table table-sm table-bordered mb-0" style="table-layout: fixed">
        <thead>
        <tr class="bg-light">
            <th class="px-2 text-secondary border-bottom-0 width-30px">#</th>
            <th class="px-2 text-secondary border-bottom-0">Category</th>
            <th class="px-2 text-secondary border-bottom-0">Title</th>
            <th class="px-2 text-secondary border-bottom-0">Description</th>
            <th class="px-2 text-secondary border-bottom-0">&nbsp;</th>
        </tr>
        </thead>
        <tbody>
            <tr v-for="(item, index) in items" :class="item.is_open ? '' : 'opacity-60'">
                <td class="px-2">@{{ index + 1 }}</td>
                <td class="px-2" v-html="item.category"></td>
                <td class="px-2" v-html="item.title"></td>
                <td class="px-2" v-html="item.description"></td>
                <td class="px-2">
                    <a class="mr-2 c-pointer" v-on:click.prevent="showPopup('other-popup', item)">Edit</a>
                    <a class="mr-2 c-pointer" v-if="item.is_open" v-on:click.prevent="closeItem(item)">Close</a>
                    <a class="mr-2 c-pointer" v-if="!item.is_open" v-on:click.prevent="openItem(item)">Open</a>
                    <a class="mr-2 c-pointer" v-if="!item.is_entry_error" v-on:click.prevent="setIsEntryErrorToTrue(item)">@{{item.is_entry_error}}-setIsEntryErrorToTrue</a>
                    <a class="mr-2 c-pointer" v-if="item.is_entry_error" v-on:click.prevent="setIsEntryErrorToFalse(item)">setIsEntryErrorToFalse</a>
                    <a class="mr-2 c-pointer" v-if="!item.has_assigned_pro_signed" v-on:click.prevent="signAsAssignedPro(item)">signAsAssignedPro</a>
                    <a class="mr-2 c-pointer" v-if="item.has_assigned_pro_signed" v-on:click.prevent="undoSignAsAssignedPro(item)">undoSignAsAssignedPro</a>
                    <a class="mr-2 c-pointer" v-if="!item.has_manager_pro_signed" v-on:click.prevent="signAsManagerPro(item)">signAsManagerPro</a>
                    <a class="mr-2 c-pointer" v-if="item.has_manager_pro_signed" v-on:click.prevent="undoSignAsManagerPro(item)">undoSignAsManagerPro</a>
                    <a class="mr-2 c-pointer" v-if="!item.has_ordering_pro_signed" v-on:click.prevent="signAsOrderingPro(item)">signAsOrderingPro</a>
                    <a class="mr-2 c-pointer" v-if="item.has_ordering_pro_signed" v-on:click.prevent="undoSignAsOrderingPro(item)">undoSignAsOrderingPro</a>
                    <a class="mr-2 c-pointer" v-if="!item.has_initiating_pro_signed" v-on:click.prevent="signAsInitiatingPro(item)">signAsInitiatingPro</a>
                    <a class="mr-2 c-pointer" v-if="item.has_initiating_pro_signed" v-on:click.prevent="undoSignAsInitiatingPro(item)">undoSignAsInitiatingPro</a>
                    <template v-for="proType in proTypes">
                    <a class="mr-2 c-pointer" v-on:click.prevent="showProUpdatePopup('other-popup', proType, item)">Update @{{proType}} Pro</a>
                    </template>
                </td>
            </tr>
        </tbody>
    </table>
    <div class="stag-popup stag-popup-sm mcp-theme-1" stag-popup-key="other-popup">
        <form method="POST" action="/api/appointment/create" class="overflow-visible">
            <h3 class="stag-popup-title mb-2">
                <span>@{{ popupMode === 'add' ? 'Add Item' : 'Edit Item' }}</span>
                <a href="#" class="ml-auto text-secondary"
                   onclick="return closeStagPopup()"><i class="fa fa-times-circle"></i></a>
            </h3>
            <div class="mb-2">
                <label class="text-sm text-secondary mb-1">Category</label>
                <input required type="text" v-model="popupItem.category" class="form-control form-control-sm">
            </div>
            <div class="mb-2">
                <label class="text-sm text-secondary mb-1">Title</label>
                <input required type="text" v-model="popupItem.title" class="form-control form-control-sm">
            </div>
            <div class="mb-2">
                <label class="text-sm text-secondary mb-1">Description</label>
                <textarea type="text" rows="3" v-model="popupItem.description" class="form-control form-control-sm"></textarea>
            </div>
            <div class="d-flex align-items-center justify-content-center mt-3">
                <button type="button" class="btn btn-sm btn-primary mr-2" v-on:click.prevent="savePopupItem()">Submit</button>
                <button type="button" class="btn btn-sm btn-default border" onclick="return closeStagPopup()">Cancel</button>
            </div>
        </form>
    </div>
    <div class="stag-popup stag-popup-sm mcp-theme-1" stag-popup-key="other-pro-update-popup">
        <form method="POST" class="overflow-visible">
            <h3 class="stag-popup-title mb-2">
                <span>Update @{{ proToUpdate}} Pro</span>
                <a href="#" class="ml-auto text-secondary"
                   onclick="return closeStagPopup()"><i class="fa fa-times-circle"></i></a>
            </h3>
            <div class="form-group mb-2">
                <label class="text-sm text-secondary mb-1">@{{proToUpdate}} Pro</label>
                <select v-model="newProUid" class="form-control">
                    <option value="">-- select ---</option>
                    @foreach($pros as $pro)
                    <option value="{{$pro->uid}}">{{$pro->name_first}} {{$pro->name_last}}</option>
                    @endforeach
                </select>
            </div>
            <div class="d-flex align-items-center justify-content-center mt-3">
                <button type="button" class="btn btn-sm btn-primary mr-2" v-on:click.prevent="updateTicketPro()">Submit</button>
                <button type="button" class="btn btn-sm btn-default border" onclick="return closeStagPopup()">Cancel</button>
            </div>
        </form>
    </div>
</div>

<script>
    (function() {
        <?php
        $tickets = $patient->tickets->filter(function($_item) {
            return $_item->category === 'other';
        });
      
        $items = [];
        foreach ($tickets as $ticket) {
            $item = json_decode($ticket->data);
            $item->uid = $ticket->uid;
            $item->is_open = $ticket->is_open;
            $item->has_assigned_pro_signed = $ticket->has_assigned_pro_signed;
            $item->has_initiating_pro_signed = $ticket->has_initiating_pro_signed;
            $item->has_manager_pro_signed = $ticket->has_manager_pro_signed;
            $item->has_ordering_pro_signed = $ticket->has_ordering_pro_signed;
            $item->is_entry_error = $ticket->is_entry_error;
            $items[] = $item;
        }
        ?>
        function init() {
            let items = [];
            let otherApp = new Vue({
                el: '#otherApp',
                delimiters: ['@{{', '}}'],
                data: {
                    popupMode: 'add',
                    items: {!! json_encode($items) !!},
                    popupItem: {
                        uid: '',
                        is_open: true,
                        category: '',
                        title: '',
                        description: ''
                    },
                    proToUpdate: '',
                    proTypes: ['Assigned', 'Manager', 'Initiating', 'Ordering'],
                    newProUid:''
                },
                methods: {
                    showPopup: function(_name, _item) {
                        closeStagPopup();
                        this.popupMode = _item ? 'edit' : 'add';
                        this.popupItem = _item ? JSON.parse(JSON.stringify(_item)) : {
                            uid: '',
                            is_open: true,
                            category: '',
                            title: '',
                            description: '',
                        };
                        let self = this;
                        Vue.nextTick(function() {
                            showStagPopup('other-popup', true);
                        });
                    },
                    savePopupItem: function() {
                        let form = $('#otherApp form').first();
                        if(!form[0].checkValidity()) {
                            form[0].reportValidity();
                            return false;
                        }

                        showMask();
                        let payload = {};
                        if(this.popupMode === 'add') {
                            payload.clientUid = '{{ $patient->uid }}';
                            payload.category = 'other';
                            payload.assignedProUid = '{{ $pro->uid  }}';
                            payload.managerProUid = '{{ $pro->uid  }}';
                            payload.orderingProUid = '{{ $pro->uid  }}';
                            payload.initiatingProUid = '{{ $pro->uid  }}';
                            payload.data = JSON.stringify(this.popupItem);
                        }
                        else {
                            payload.uid = this.popupItem.uid;
                            payload.newData = JSON.stringify(this.popupItem);
                        }

                        $.post(
                            '/api/ticket/' + (this.popupMode === 'add' ? 'create' : 'updateData'),
                            payload,
                            function(_data) {
                                console.log(_data);
                                fastReload();
                            },
                            'json');

                        return false;
                    },

                    showProUpdatePopup: function(_name, _proToUpdate, _item) {
                        closeStagPopup();
                        this.proToUpdate = _proToUpdate
                        this.popupItem =JSON.parse(JSON.stringify(_item))
                        let self = this;
                        Vue.nextTick(function() {
                            showStagPopup('other-pro-update-popup', true);
                        });
                    },

                    updateTicketPro: function() {
                        let self  = this;
                        let form = $('#otherApp form').first();
                        if(!form[0].checkValidity()) {
                            form[0].reportValidity();
                            return false;
                        }

                        showMask();
                        let payload = this.popupItem;
                        payload.newProUid = self.newProUid;
                       
                        $.post(
                            '/api/ticket/update' + self.proToUpdate +'Pro',
                            payload,
                            function(_data) {
                                console.log(_data);
                                fastReload();
                            },
                            'json');

                        return false;
                    },

                    closeItem: function(_item) {
                        showMask();
                        $.post('/api/ticket/close', {
                            uid: _item.uid
                        }, function(_data) {
                            fastReload();
                        });
                    },

                    openItem: function(_item) {
                        showMask();
                        $.post('/api/ticket/open', {
                            uid: _item.uid
                        }, function(_data) {
                            fastReload();
                        });
                    },

                    setIsEntryErrorToTrue: function(_item){
                        showMask();
                        $.post('/api/ticket/setIsEntryErrorToTrue', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        });
                    },

                    setIsEntryErrorToFalse: function(_item){
                        showMask();
                        $.post('/api/ticket/setIsEntryErrorToFalse', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    signAsAssignedPro: function(_item){
                        showMask();
                        $.post('/api/ticket/signAsAssignedPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    undoSignAsAssignedPro: function(_item){
                        showMask();
                        $.post('/api/ticket/undoSignAsAssignedPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    signAsManagerPro: function(_item){
                        showMask();
                        $.post('/api/ticket/signAsManagerPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    undoSignAsManagerPro: function(_item){
                        showMask();
                        $.post('/api/ticket/undoSignAsManagerPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    signAsOrderingPro: function(_item){
                        showMask();
                        $.post('/api/ticket/signAsOrderingPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    undoSignAsOrderingPro: function(_item){
                        showMask();
                        $.post('/api/ticket/undoSignAsOrderingPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    signAsInitiatingPro: function(_item){
                        showMask();
                        $.post('/api/ticket/signAsInitiatingPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    },

                    undoSignAsInitiatingPro: function(_item){
                        showMask();
                        $.post('/api/ticket/undoSignAsInitiatingPro', {
                            uid:_item.uid
                        }, function(_data){
                           fastReload();     
                        })
                    }
                },
                mounted: function () {
                }
            })
        }
        addMCInitializer('other', init, '#otherApp');
    })();
</script>
